package com.xydl.cac.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.util.Date;

@JsonInclude(JsonInclude.Include.NON_NULL)
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "warning")
@ApiModel("告警信息表")
public class Warning {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Integer id;

    @ApiModelProperty("装置ID")
    @Column(name = "sensor_id")
    private Integer sensorId;

    @ApiModelProperty("装置名称")
    @Column(name = "sensor_name")
    private String sensorName;

    @ApiModelProperty("主设备名称")
    @Column(name = "zsb_name")
    private String zsbName;

    @ApiModelProperty("规则ID")
    @Column(name = "rule_id")
    private Integer ruleId;

    @ApiModelProperty("字段名")
    @Column(name = "field")
    private String field;

    @ApiModelProperty("数据采集时间")
    @Column(name = "d_time")
    private Date dTime;

    @ApiModelProperty("告警时间")
    @Column(name = "warn_time")
    private Date warnTime;

    @ApiModelProperty("告警值")
    @Column(name = "warn_value")
    private String warnValue;

    @ApiModelProperty("阈值")
    @Column(name = "threshold")
    private String threshold;

    @ApiModelProperty("告警信息")
    @Column(name = "warn_desc")
    private String warnDesc;

    @ApiModelProperty("触发信息")
    @Column(name = "trigger_desc")
    private String triggerDesc;

    @ApiModelProperty("告警级别 0:低 1:中 2:高")
    @Column(name = "warn_level")
    private Integer warnLevel;

    @ApiModelProperty("处理状态")
    @Column(name = "state")
    private String state;

    @ApiModelProperty("处理结果描述")
    @Column(name = "process")
    private String process;

    @ApiModelProperty("处理人id")
    @Column(name = "process_user")
    private String processUser;

    @ApiModelProperty("处理时间")
    @Column(name = "process_time")
    private Date processTime;

}